/*
*                     LTR11.
*     dll--
*        
*      .
* !!!!!!
*       
*     -> wlusbapi.lib
*   -  cvi     msvc,  
*       <e140>/dll/MicroSoft/wlusbapi.lib
*   -  cvi     borland,  
*       <e140>/dll/Borland/wlusbapi.lib
*/


/*   -     LTR11 */
#include "ltr\\include\\ltr11api.h"
/*    */
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <conio.h>



/*===============================================================================================*/
#define ACQ_BLOCK_QNT  (2)           /*       */
#define ACQ_BLOCK_SIZE (1024)        /*     */
/*===============================================================================================*/

/*===============================================================================================*/
static DWORD WINAPI AcquireThread (LPVOID param);
static void         printf_oem    (char *s);
/*===============================================================================================*/

/*===============================================================================================*/
static double acq_buf[ACQ_BLOCK_QNT][ACQ_BLOCK_SIZE];
/*     */
static volatile int AcqBlockReady[ACQ_BLOCK_QNT];
static TLTR11 hltr11;                /*   LTR11 */
static volatile int RunFlag = 0;     /*     */
/*===============================================================================================*/

/*===============================================================================================*/
/*-----------------------------------------------------------------------------------------------*/
static DWORD WINAPI AcquireThread(LPVOID param)
{
	/* ,      . */

	/* -       */
	const DWORD acq_time_out = (DWORD)(ACQ_BLOCK_SIZE / (hltr11.ChRate * hltr11.LChQnt) + 1000);
	DWORD       data_buf[ACQ_BLOCK_SIZE];
	DWORD       exit_val = LTR_OK;
	INT         ltr11_status = LTR_OK;


	/*    */
	ltr11_status = LTR11_Start(&hltr11);
	if (ltr11_status == LTR_OK)
	{
		/*
		while (RunFlag)
		{
		//    LTR11 
		ltr11_status = LTR_Recv(&hltr11.Channel, data_buf, NULL, ACQ_BLOCK_SIZE, acq_time_out);
		if (ltr11_status > 0 && ltr11_status == ACQ_BLOCK_SIZE)
		{
		int block_number;
		//       

		//    
		block_number = 0;
		while (block_number < ACQ_BLOCK_QNT && AcqBlockReady[block_number])
		block_number++;
		if (block_number < ACQ_BLOCK_QNT)
		{
		INT data_size = ACQ_BLOCK_SIZE;

		//        
		ltr11_status = LTR11_ProcessData(&hltr11, data_buf, acq_buf[block_number],
		&data_size, TRUE, TRUE);
		if (ltr11_status == LTR_OK)
		{
		AcqBlockReady[block_number] = 1;
		}
		else
		{
		RunFlag = 0;
		}
		}
		}
		else
		{
		RunFlag = 0;
		}
		}
		*/

		if (ltr11_status != LTR_OK) (void)LTR11_Stop(&hltr11);
		else                        ltr11_status = LTR11_Stop(&hltr11);
	}

	exit_val = (DWORD)ltr11_status;
	ExitThread(exit_val);

	return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int main(int argc, char* argv[])
{

#define MAX_MSG_SIZE (512)

	int  block_number;
	char msg[MAX_MSG_SIZE]="";
	INT  ltr11_status;


	for (block_number = 0; block_number < ACQ_BLOCK_QNT; block_number++)
		AcqBlockReady[block_number] = 0;

	LTR11_Init(&hltr11);              /*    */


	/*     ,    1 */
	ltr11_status = LTR11_Open(&hltr11, SADDR_DEFAULT, SPORT_DEFAULT, "", 7);
	if (ltr11_status == LTR_OK)       /*     */
	{
		/*    */
		ltr11_status = LTR11_GetConfig(&hltr11);
		if (ltr11_status == LTR_OK)   /*    */
		{
			/*     */
			sprintf(msg, "##    : %s\n"
				"##     : %s\n"
				"##    : %u.%u\n",
				hltr11.ModuleInfo.Name, hltr11.ModuleInfo.Serial,
				(hltr11.ModuleInfo.Ver >> 8) & 0xFF, hltr11.ModuleInfo.Ver & 0xFF);
			printf_oem(msg);

			/*     */
			/*     -  */
			hltr11.StartADCMode = LTR11_STARTADCMODE_INT;
			/*    -  */
			hltr11.InpMode      = LTR11_INPMODE_INT;
			/*    - 4 */
			hltr11.LChQnt       = 4;
			/*     */
			/*  - 10,  - 16-,   - 4 */
			hltr11.LChTbl[0] = (0 << 6) | (0 << 4) | (4 << 0);
			/*  - 2.5,  -   ,   - 4 */
			hltr11.LChTbl[1] = (1 << 6) | (1 << 4) | (4 << 0);
			/*  - 0.6,  - 32- ( 1..16),   - 1 */
			hltr11.LChTbl[2] = (2 << 6) | (2 << 4) | (1 << 0);
			/*  - 0.15,  - 32- ( 17..32),   - 9 */
			hltr11.LChTbl[3] = (3 << 6) | (3 << 4) | (9 << 0);
			/*    */
			hltr11.ADCMode = LTR11_ADCMODE_ACQ;
			/*   - 100  */
			hltr11.ADCRate.prescaler = 1;
			hltr11.ADCRate.divider   = 149;

			ltr11_status = LTR11_SetADC(&hltr11);
			if (ltr11_status == LTR_OK)         /*    */
			{
				int        ch_num;
				FILE       *file_out;
				const char out_file_name[] = "adc_data.bin";

				sprintf(msg, ">>    LTR11   :\n"
					"##     = %i\n"
					"##     = %i\n"
					"##      = %.2f\n"
					"##     = %d\n",
					hltr11.StartADCMode, hltr11.InpMode, hltr11.ChRate, hltr11.LChQnt);
				printf_oem(msg);
				for (ch_num = 0; ch_num < hltr11.LChQnt; ch_num++)
				{
					sprintf(msg, "##   = %i   = %0.2Xh\n", ch_num + 1,
						hltr11.LChTbl[ch_num]);
					printf_oem(msg);
				}

				file_out = fopen(out_file_name, "wb");
				if (file_out != NULL)
				{
					DWORD  acq_thread_id;
					HANDLE hnd_acq_thread;
					DWORD  thread_status;

					sprintf(msg, ">>  <%s> \n", out_file_name);
					printf_oem(msg);

					RunFlag = 1;
					/*        */
					hnd_acq_thread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)AcquireThread,
						NULL, 0, &acq_thread_id);
					if (hnd_acq_thread != NULL)  /*    */
					{
						int block_counter;

						printf_oem(">>    \n");

						block_counter = 0;
						block_number  = 0;
						while (RunFlag)
						{
							/*     */
							if (AcqBlockReady[block_number])
							{
								/*       */
								const int number_acq_block = 100;

								/*    */

								/*     */
								fwrite(acq_buf[block_number], sizeof acq_buf[0][0], ACQ_BLOCK_SIZE,
									file_out);
								/*       */
								AcqBlockReady[block_number] = 0;
								/*     */
								if (++block_number >= ACQ_BLOCK_QNT)
									block_number = 0;
								/*      */
								block_counter++;

								sprintf(msg, ">> block_counter = %i\n", block_counter);
								printf_oem(msg);
								if (block_counter >= number_acq_block)
								{
									/*    */
									printf_oem(">>    .\n");
									RunFlag = 0;
								}
							}
							else if (kbhit() && getch() == 27)
							{
								printf_oem(">>  .\n");
								RunFlag = 0;
							}
						}
						/*      */
						(void)WaitForSingleObject(hnd_acq_thread, INFINITE);
						(void)GetExitCodeThread(hnd_acq_thread, &thread_status);

						ltr11_status = (INT)thread_status;
						if (ltr11_status != LTR_OK)
						{
							/*      */
							printf_oem(">>    :\n");
							printf_oem((char *)LTR11_GetErrorString(ltr11_status));
						}

						printf_oem(">>    .\n");

						CloseHandle(hnd_acq_thread);
						printf_oem(">>    .\n");

						fclose(file_out);
					} /*if (hnd_acq_thred != NULL)*/
					else
					{
						printf_oem(">> :      .\n");
					}
				} /*if (file_out != NULL)*/
				else
				{
					sprintf(msg, ">> :     <%s>.\n", out_file_name);
					printf_oem(msg);
				}
			} /*if (ltr11_status == LTR_OK)*/
			else
			{
				printf_oem(">>    :\n   ");
				printf_oem((char *)LTR11_GetErrorString(ltr11_status));
			}
		} /*if (ltr11_status == LTR_OK)*/
		else
		{
			printf_oem(">>    :\n   ");
			printf_oem((char *)LTR11_GetErrorString(ltr11_status));
		}

		/*      */
		(void)LTR11_Close(&hltr11);
	} /*if (ltr11_status == LTR_OK)*/
	else
	{
		printf_oem(">>     LTR11:\n   ");
		printf_oem((char *)LTR11_GetErrorString(ltr11_status));
	}


	printf_oem(">>  ,   \n");
	while(!kbhit())
	{
		continue;
	}
	(void)getch();

	return 0;

#undef MAX_MSG_SIZE
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
static void printf_oem(char *s)
{
	/*     DOS */
	char *pstr;


	pstr = malloc((strlen(s) + 1) * sizeof(char));

	if (pstr != NULL)
	{
		CharToOem(s, pstr);
		printf(pstr);
		free(pstr);
	}
}
/*-----------------------------------------------------------------------------------------------*/
/*===============================================================================================*/
